diff -Naur u-boot-2006-05-10-1800/cpu/microblaze/start.S u-boot-2006-05-10-1800-microblaze/cpu/microblaze/start.S
--- u-boot-2006-05-10-1800/cpu/microblaze/start.S	2006-05-10 17:43:20.000000000 +0200
+++ u-boot-2006-05-10-1800-microblaze/cpu/microblaze/start.S	2006-06-15 21:06:04.000000000 +0200
@@ -1,6 +1,8 @@
 /*
+ * (C) Copyright 2006 Michal Simek
  * (C) Copyright 2004 Atmark Techno, Inc.
  *
+ * Michal  SIMEK <www.monstr.eu>
  * Yasushi SHOJI <yashi@atmark-techno.com>
  *
  * See file CREDITS for list of people who contributed to this
@@ -27,10 +29,55 @@
 	.text
 	.global _start
 _start:
+	addi	r1, r0, CFG_INIT_SP_OFFSET	/* init stack pointer */
+	/* add opcode instruction for 32bit jump - 2 instruction imm & brai*/
+	addi 	r6,r0,0xb000	/* hex b000 opcode imm */
+	bslli 	r6,r6,16	/* shift */
+	swi 	r6,r0,0x0	/* reset address */
+	swi 	r6,r0,0x8	/* user vector exception */
+	swi 	r6,r0,0x10  	/* interrupt */
+	swi 	r6,r0,0x20  	/* hardware exception */

-	addi	r1, r0, CFG_SDRAM_BASE	/* init stack pointer */
-	addi	r1, r1, CFG_SDRAM_SIZE	/* set sp to high up */
+	addi 	r6,r0,0xb808 	/* hew b808 opcode brai*/
+	bslli 	r6,r6,16
+	swi 	r6,r0,0x4	/* reset address */
+	swi 	r6,r0,0xC	/* user vector exception */
+	swi 	r6,r0,0x14	/* interrupt */
+	swi 	r6,r0,0x24  	/* hardware exception */

-	brai	board_init
+#ifdef CFG_RESET_ADDRESS
+	/* reset address */
+	addik 	r6,r0,CFG_RESET_ADDRESS
+	sw 	r6,r1,r0
+	lhu 	r7,r1,r0
+	shi 	r7,r0,0x2
+	shi 	r6,r0,0x6
+#endif
+	/* user_vector_exception */
+	addik 	r6,r0,_exception_handler
+	sw 	r6,r1,r0
+	lhu 	r7,r1,r0
+	shi 	r7,r0,0xa
+	shi 	r6,r0,0xe
+#ifdef CFG_INTC_0
+	/* interrupt_handler */
+	addik 	r6,r0,_interrupt_handler
+	sw 	r6,r1,r0
+	lhu 	r7,r1,r0
+	shi 	r7,r0,0x12
+	shi 	r6,r0,0x16
+#endif
+	/* hardware exception */
+	addik 	r6,r0,_hw_exception_handler
+	sw 	r6,r1,r0
+	lhu 	r7,r1,r0
+	shi 	r7,r0,0x22
+	shi 	r6,r0,0x26

+	/* enable instruction and data cache */
+	mfs r12,rmsr
+	ori r12,r12, 0xa0
+	mts rmsr,r12
+	/* jumping to board_init */
+	brai	board_init
 1:	bri	1b
 
